# Service account to run elastic search.
apiVersion: v1
kind: ServiceAccount
metadata:
  name: education-frontend-app
---
# Service to expose and loadbalance between pods.
apiVersion: v1
kind: Service
metadata:
  name: education-frontend-app
spec:
  selector:
    app: education-frontend-app
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: education-frontend-app
  labels:
    app: education-frontend-app
spec:
  selector:
    matchLabels:
      app: education-frontend-app
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  template:
    metadata:
      labels:
        app: education-frontend-app
    spec:
      # Pod to launch the service.
      serviceAccountName: education-frontend-app
      securityContext:
          # Your app shall always run as nonroot.
          runAsNonRoot: true
      affinity:
        # Avoid to run many pods on same physical node. It increases reliability.
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 1
            podAffinityTerm:
              labelSelector:
                matchLabels:
                  app: education-frontend-app
              topologyKey: kubernetes.io/hostname
      containers:
      - name: castaway
        image: docker-images.jobtechdev.se/education-frontend-app/education-frontend-app:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 8080
        securityContext:
          # Your app shall always have the container file system read only. Use volumes for temp areas etc.
          readOnlyRootFilesystem: false
        resources:
          limits:
            memory: "2Gi"
          requests:
            cpu: "500m"
            memory: "500Mi"
        volumeMounts:
          - name: education-frontend-env-variables
            mountPath: /usr/share/nginx/html/assets/environments
      volumes:
        - name: education-frontend-env-variables
          configMap:
            name: education-frontend-env-variables-config
